clear
clc

% Rcupration des valeurs finales de regderb3 pour les simulations futures  quaternion
% La valeur finale [ p q r q0 q1 q2 q3] a t stocke dans le fichier initpqrQ.mat

load initpqrQ.mat;
initpqrQ =initpqrQ(2:8,length(initpqrQ));
initpqrQ=initpqrQ';  % En colonne vecteur ( 7 composantes )

% Rcupration des valeurs finales de regderb3 pour les simulations futures sans quaternion
% La valeur finale [ angles vitesses] a t stocke dans le fichier initpqrQ.mat

load init_tmc.mat;
init_tmc =init_by3(2:7,length(init_by3));
init_tmc=init_tmc';   % En colonne vecteur (6 composantes )

% Initialisation de la vitesse de la roue par la simulation prcdente

vitesseroue=0; % Initialisation de la vitesse initiale de la roue pour la nouvelle simulation

load vit_roue.mat;


rotation_initiale=vitesseroue(1,length(vitesseroue));  % Valeur initiale de la vitesse de la roue


% ******************* Donnes spcifiques  la roue de raction ******************

% Inertie de la roue

 jroue=3.2e-5;
 J_ROUE=3.2e-5; 


% ******************** Valeurs de consigne************

consigne_tangage=0;
consigne_roulis=0;
consigne_lacet=0;


% ******************************************************

% Dclaration de visibilit des variables pour tous les programmes qui les appellent
% en interne ou externe ( en somme variables globales )

global Ir It Il Irl Itl Irt Asat etat_init vitesse_rotation altitude points_trace 

global tau vitesse_angul_mini jroue J vitesseroue gain_lacet K_tumbling couple_max_roue moment_max_bobine


% *****************  Initialisation du detumbling ****************

K_tumbling=1; % Le detumbling de rduction des vitesses est enclench
              % il ne s'arrtra que si un test le fait passer  0
              % alors se dclenchera l'acquisition grossire qui doit
              % conduire au pointage fin

% ******************** Donnes de saturation roue ou bobines *********

couple_max_roue=4e-6;  % Nm

moment_max_bobine=0.2;  % Am



% *********************************************************


% *********************************************************

vitesse_angul_mini=3e-3;  % Vitesse angulaire au dessous de laquelle on passe au mode fin, commande du stop


% *********************************************************

% Gain de la matrice de gain pour la drive de B

% Constante de temps 

 tau=200;


% *********************************************************

% Nombre de points du trac

 points_trace=20000;


% *********************************************************

%                                      Cett partie gnrale  initialise toutes les simulations 


% *********************************************************

% Matrice d''inertie satellite

Ir=32e-3;It=36e-3;Il=32e-3;Irt=5.8e-5;Irl=3e-4;Itl=4e-3;

Asat=[Ir -Irt -Irl;
         -Irt It -Itl;
            -Irl -Itl Il];

% Caractristiques de l'orbite du satellite

altitude_orbite=817;		% altitude satellite en km
rayon_orbital=(6378+altitude_orbite)*1000;
vitesse_rotation=sqrt(39.86e13/rayon_orbital^3);
				% pulsation orbitale en rd/s
inclinaison=98.7*pi/180;

periode_orbitale=2*pi/vitesse_rotation;

%   ***********************  VALEURS INITIALES DU TUMBLING  ***************************

% Initialisation en vitesses (rd/s)

v_roulis0=0.06;
v_tangage0=0.05;
v_lacet0=0.01;

v_roulis0=0.006;v_tangage0=0.005;v_lacet0=0.001;

% Initialisation en position (rd)

roulis0=0.1;
tangage0=-0.1;
lacet0=0.05;

% *********************************************************

%  ***************** DONNEES PD ROUE TANGAGE********************
 
 K_PD=220e-7*4;      %   Gain proportionnel
 F_PD=5*7.5e-4/10;    %   Gain amortissement drive

 I_PD=1e-10;       %   Gain intgrateur non utilis

 gain_roue=10;


% ***************** MATRICE (6x3) DE GAINS PD ********************');


gain=[1e-6 0 0 6e-7 0 0;
           0 2e-6 0 0 3e-6 0;
             0 0 4e-6 0 0 1.8e-6];


% ***************** DONNEES PERTURBATIONS********************

 cpl_aero1=0;cpl_aero2=3.63e-8;cpl_aero3=0;  % COUPLE AERODYNAMIQUE

 cpl_magn_res1=1.5e-7;cpl_magn_res2=1.5e-7;cpl_magn_res3=1.5e-7;  % COUPLE MAGNETIQUE RESIDUEL        

%-----------------------------------

 % ***************** DONNEES PID TANGAGE TRAITE EQUATEUR POLES ********************
 
 K_PID=47e-7*3;           %   Gain proportionnel
 F_PID=3e-4/10;            %   Gain amortissement drive
 I_PID=1e-8;            %   Gain intgrateur
 
 gain_roue=10;

%***************** DONNEES PID ROULIS *************************
 
 K_PID_ROULIS=16e-7;   %   Gain proportionnel
 F_PID_ROULIS=32e-6;     %   Gain amortissement drive
 I_PID_ROULIS=1e-8;     %   Gain intgrateur
 
 gain_roulis=250000/2;

% ***************** DONNEES PID LACET **************************
 
 K_PID_LACET=5.5e-7;   %   Gain proportionnel
 F_PID_LACET=33e-6;     %   Gain amortissement drive
 I_PID_LACET=2e-8;     %   Gain intgrateur
 gain_lacet=200000/2;

%  ***************** DONNEES PID TANGAGE ********************
 
 K_PID_TANGAGE=36e-7;      %   Gain proportionnel
 F_PID_TANGAGE=72e-6;    %   Gain amortissement drive

 I_PID_TANGAGE=1e10;       %   Gain intgrateur non utilis

 gain_tangage=330000/2;


% ***************** DONNEES PERTURBATIONS ********************

mom_magn_res=0.01; %  Moment magntique rsiduel en Am

alpha=sqrt(1/3);beta=sqrt(1/3);gamma=sqrt(1/3); % Direction unitaire /satellite du moment rsiduel

cpl_aero1=0;
cpl_aero2=-3.6e-8;% COUPLE AERODYNAMIQUE
cpl_aero3=0;


% cpl_magn_res1=1.5e-7;cpl_magn_res2=1.5e-7;cpl_magn_res3=1.5e-7;  % COUPLE MAGNETIQUE RESIDUEL

%  *******************************  CONSIGNES   ************************* 

 consigne_tangage=0;  %   Valeur de consigne de l'angle de tangage  atteindre, en radian 
 consigne_roulis=-0;
 consigne_lacet=0;

% **********************************************************************

% ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********
% Rotation absolue compose de la rotation par rapport au repre orbital
% et de la rotation  vitesse_rotation porte par Y

vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    vitesse_rotation*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    vitesse_rotation*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    vitesse_rotation*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe XYZ  la base satellite xyz
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% determinant=det(Pmat),% ************* Bien vrifi ***********

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

qt00=(1+trac)^0.5/2;

qt10=(1-trac+2*Pmat(1,1))^0.5/2;

qt20=(1-trac+2*Pmat(2,2))^0.5/2;

qt30=(1-trac+2*Pmat(3,3))^0.5/2;

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((-Pmat(1,2)+Pmat(2,1))/4/qt00);
end

if abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);
end

if abs(qt20)>1e-8, 
qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);
end

if abs(qt30)>1e-8, 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((-Pmat(1,2)+Pmat(2,1))/4/qt30);
end

% Q=[qt00 qt10 qt20 qt30], %  ********* devrait avoir une norme 1

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

% normQ=norm(Q),% ******** vrifi *******

% energie=0.5*[vp0 vq0 vr0]*Asat*[vp0 vq0 vr0]',  %  ********  Energie devrait rester constante

etat_init=[vp0 vq0 vr0 Q(1) Q(2) Q(3) Q(4)]; 

% clear trac altitude qt00 qt10 qt20 qt30 vp0 vq0 vr0 Q Pmat

vitesseroue=0;
end








