function y=jw_rot(u);

global Asat vitesseroue jroue

% **************************************************
% SIMULATION DE LA STABILISATION D'UN SATELLITE PAR 
% GRADIENT DE GRAVITE ET AMORTISSEMENT PAR DES
% MAGNETOCOUPLEURS FONCTIONNANT AVEC DES COMMANDES
% BASEES SUR LA DERIVEE DU CHAMP MAGNETIQUE TERRESTRE
% **************************************************
%
% Cette fonction calcule le couplage roue - satellite
% dans le calcul de la drive de la rotation (p q r )

% **************************************************

% ------------------  DEBUT PROGRAMME  ---------------

% ************************************************
% Le vecteur d'entre pour le traitement du systme
% diffrentiel est  7 composantes.
%
%	u(1)=p    rotation absolue satellite sur x
%	u(2)=q    ...........................sur y
%	u(3)=r    ...........................sur z
%
%	u(4)=q0   Premire composante du quaternion
%	u(5)=q1   Deuxime ........................
%	u(6)=q2   Troisime .......................
%	u(7)=q3   Quatrime .......................

% *********** Detail de la fonction****************
% ELLE PERMET LE CALCUL DU SECOND MEMBRE DE L'EQUATION 
% TMC, NE CONCERNANT QUE LA MATRICE D'INERTIE Asat ET 
% LE VECTEUR ROTATION INERTIEL DE COMPOSANTES p q r

% **************************************************

 % vecteur rotation inertiel sur x y z ( dim 3 vert )

 p=u(1);q=u(2);r=u(3);

 % Moment cintique de la roue en axes satellite 

 mom_cin_roue=jroue*vitesseroue,
 vitesseroue,

 cplomegaroue=mom_cin_roue*[r 0 -p]';                     % Termes de couplage roue/rotation

 couplage=inv(Asat)*cplomegaroue;                         % Termes exprims dans le second membre des quations
                                                          % en p q r

% Sortie de la fonction( dim 3 verticale)

y=couplage;

end

% *******************************************************

  